(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenCF.sml,v
   Comment: Code generator to ANSI C based on flattening.
   Release: scope-0-15_final 

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   CodGenCF.sml,v 1.8 2003/07/22 08:34:33 wasowski Exp
*)

structure CodGenCF : CODGEN = struct

(* some interface *)

open Err CodGenC List Say Types Flat
infix 3 --;
infix 4 INIT;


(* Types *)

(* type of options for code generator *)

type aor = Absyn.attr
type atr = Absyn.static

type options = bool * int * string option * string option 

(* debug, queue_len, action_prototypes_file, output file root, state-based-conf vs flags *)

type model  = (aor,atr) Absyn.model
type system = (aor,atr) Absyn.system

(* implementation *)

(* compile a model to LR with type resolution *)

fun comp (debug, queuelen, externhdr,ofile) ifile (sys :system): unit =
	let val fsys     = Flatten.fl_sys sys
	    val lrsystem = CodGenCF_front.comp_system queuelen fsys
			   handle e => intErr e 200307213 
	    val lrsizes  = CodGenCF_front.resolve_types lrsystem
			   handle e => intErr e 200307214
	    val sch      = CodGenCF_schedule.schedule_system lrsystem lrsizes
			   handle e => intErr e 200307215 
	    val csystem  = CodGenCF_back.cg_system (debug,externhdr) 
			   lrsystem lrsizes sch handle e => intErr e 200307217
	in CodGenC_dump.dump_system ofile csystem end
	handle e => intErr e 200307220

(* main function *)  

fun compile options  ifile model  =
	app (comp options ifile) model
	
end
