(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenC_schedule.sml,v
   Comment: Common parts of scheduler for C code generators
   Release: scope-0-15_final 

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   CodGenC_schedule.sml,v 1.3 2003/07/21 15:34:23 wasowski Exp 
*)
structure CodGenC_schedule = struct

open Common LR

(* assign numbers to event names *)

fun schedule_events (evtypes :evtype env) :eenv = 
	let val names  = map #1 (SE.toList evtypes) 
	    val ids    = List.tabulate (length names, fn x=>x)
	in SE.bindZip SE.empty (names,ids) end

(* build dictionary mapping events to entries in trans array *)

fun integrate (lst :int list) (start :int) :int list * int = 
	let val offs = foldl (fn (i,e)=> hd e + i::e) [start] lst
	in (rev offs, hd offs) end


fun build_tranidx (measure :lratom list->int) (tenv :tenv) (evtypes :evtypes) :tranidx =
	let val lst        = SE.toList tenv                           
	    val names      = map #1 lst
	    val sizes      = map (measure o #2) lst
	    val (offsets,notran) = integrate sizes 0
	    val dict1      = SE.bindZip SE.empty (names,offsets)
	    val fullnames  = map #1 (SE.toList evtypes)
	    val emptytrans = List.tabulate (length fullnames,fn _ => notran)
	in SE.plus (SE.bindZip SE.empty (fullnames,emptytrans), dict1) end

end
