#!/usr/bin/perl -w 
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/preptiny.pl,v
# Comment: Compile executables for tests of reactoin speed (smoke method)
# Release: scope-0-15_final
#
#    Copyright (C) 2001-2003 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# NOTES:
#
# preptiny.pl,v 1.11 2004/05/05 21:29:05 wasowski Exp

use File::stat;
use File::Basename;
use test::src::ScopeTest;
use File::stat;

$file = "";

$compiler = "";
$outdir   = ".";
$preopts  = "";

if (! $ARGV[0]) {
    print "\n preptiny.pl codgen [output_dir [lcc|gcc [preopts]]]\n\n";
    exit;
}

$codgen=$ARGV[0]; 

if ($ARGV[1]) { $outdir   = $ARGV[1]; }
if ($ARGV[2]) { $compiler = $ARGV[2]; }
if ($ARGV[3]) { $preopts  = $ARGV[3]; }

system "mkdir -p $outdir 2> /dev/null";

sub testsmoke() {

	my $fbase = fileparse($file,qr/\.[^.]*/);
	my $retval = ((system "compilemin.pl  $file $codgen test/sandbox/ $compiler $preopts > /dev/null") == 0
		&& (system "mv -f test/sandbox/$fbase $outdir") == 0);
	my $sb = stat("$outdir/$fbase");
	printf ("%s ", $sb->size);
	return $retval;
}

ScopeTest::test_init( "$codgen compiling for size comparison" );

$success = 1;

open (MODELS, "test/src/LIST") || die "Cannot read the list of files in test/src/LIST";


while ( $file = <MODELS> ) {
	  chop $file;
	  $success = ScopeTest::dotest(\&testsmoke, $file) && $success;
}

ScopeTest::test_finalize( $success );

