#!/usr/bin/perl -w 
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tHsmConversions.pl,v
# Comment: Test HSM front-end and back-end by around compilation (fixpoint)
# Release: scope-0-15_final
#
#    Copyright (C) 2003 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# NOTES: Usage is just: "test/src/tHsmConversions.pl"
#
# tHsmConversions.pl,v 1.2 2003/05/08 17:38:32 wasowski Exp

use File::stat;
use File::Basename;
use test::src::ScopeTest;
use File::stat;

$outdir   = ".";

if ($ARGV[0]) { $outdir = $ARGV[0]; }

system "mkdir -p $outdir 2> /dev/null";

sub testf() {
	my $retval;
	#ScopeTest::remove_sandboxes();
	$retval = system ("(scope -d test/sandbox/ -o file1.hsm -chsm $file)"
		. "&& (scope -d test/sandbox -o file2.hsm -chsm test/sandbox/file1.hsm)"
		. "&& (sed 's/\\/\\*.*\\*\\///' test/sandbox/file1.hsm > test/sandbox/file1a.hsm)"
		. "&& (sed 's/\\/\\*.*\\*\\///' test/sandbox/file2.hsm > test/sandbox/file2a.hsm)"
		. "&& (cmp test/sandbox/file1a.hsm test/sandbox/file2a.hsm)") == 0;
	return $retval;
}

ScopeTest::test_init( "Hsm-Absyn conversions" );

$success = 1;

open (MODELS, "test/src/LIST") || die "Cannot read the list of files in test/src/LIST";


while ( $file = <MODELS> ) {
	  chop $file;
	  $success = ScopeTest::dotest(\&testf, $file) && $success;
}

ScopeTest::test_finalize( $success );


