#!/usr/bin/perl -w 
#
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/testsmoke.pl,v
# Comment: A shortcut for code genereting and compiling a model in smoke(debug) mode
# 	   and immediately starting a smoke test on the model
# Release: scope-0-15_final
#
#    Copyright (C) 2002-2003 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Usage:
#
# output dir cannot be omitted (in contrary to may oter scripts)
# eventno is the highest index of event (not a signal)
# print may be ommited if trace should not be printed
#
# testsmoke.pl,v 1.6 2003/07/23 11:23:29 wasowski Exp
#
use File::Basename;
use test::src::ScopeTest;

if (! $ARGV[0]) { 
	print "\ntestsmoke.pl path_to_model codgen output_dir iter eventno [preopts] print\n\n"; 
	exit;
}

$file=$ARGV[0];
$codgen=$ARGV[1];
$outdir=$ARGV[2];
$iter=$ARGV[3];
$eventno=$ARGV[4];

$print   ="";
$preopts = "";

if ($ARGV[5]) { 
	
	if ($ARGV[5] eq "print") {
		$print = $ARGV[5];
	} else { 
	
		$preopts = $ARGV[5];
		if ($ARGV[6]) {
			$print = $ARGV[6];
		}
	}
}

$fbase = fileparse($file,qr/\.[^.]*/);
$exe =  "test/src/compilesmoke.pl $file $codgen $outdir $preopts";
print $exe . "\n";

if ( (system $exe) == 0
	&& (system "$outdir/$fbase $iter $eventno $print") == 0) 
	{ exit 0; }
else { exit 1; }

