(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tparserl-parser.sml,v
   Comment: testcases for RL parsers 
   Release: scope-0-15_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


   tparserl-parser.sml,v 1.1 2003/03/10 13:24:38 wasowski Exp
*)

app load ["ListPair","Parsercomb","parserl","Test"];

open Test ParseRL Parsercomb Types;

val _ = quotation := true;

(* testcases *)

use "tparserlCases.sml";

(* initialize *)

val testname = "parserl-parser";
val _ = Test.init testname;

fun parsequote ([QUOTE s] :unit frag list)  = 
	scanList parser (valOf (scanString tokenizer s))
  | parsequote _ = raise Fail "#200303101"; (* imossible *)

fun testparser ((snippet,tokens,ast) :testcase) :bool =
	parsequote snippet = ast;

val res = ListPair.map (fn (t,n) => test testparser t n) (testcases,names)

val _ = Test.finalise testname res;

